<?php
class Articles extends Admin {
	function __construct() {
		$this->pagePos = isset($_GET['pg'])?$_GET['pg']:0;
		$this->h = New Html();
		$this->tr = New Translate();
		$this->sortMethods = array("",ARTICLES.".DATE DESC",ARTICLES.".SUBJECT",ARTICLES.".PAGEID",ARTICLES.".USERID","");  
		$this->qSelect = " SELECT ".
							ARTICLES.".ID ARTID,".ARTICLES.".SUBJECT,".ARTICLES.".DATE,".ARTICLES.".HIDE,".
							USERS.".USERNAME,".USERS.".ID IDUSERID,".USERS.".USERLEVEL,".
							PAGES.".NAME,".PAGES.".ID PAGEID,".PAGES.".USERID USERPAGEID";
		$this->qFrom = 	" FROM ".
							ARTICLES.
							" INNER JOIN ".PAGES. " ON ".ARTICLES.".PAGEID = ".PAGES.".ID".
							" INNER JOIN ".USERS." ON ".ARTICLES.".USERID = ".USERS.".ID";
		$this->qSelectCount = 	" SELECT COUNT(".ARTICLES.".ID) AS NUM";
		$this->qOrderSort = "";
		$this->qWhereArray = array();
		if (!isset($_SESSION['admin_article_sort'])) $_SESSION['admin_article_sort'] = $this->sortMethods[1];
	}
	public function update_articles() {
		// empty form
		if (count($_POST) == 1) return;
		
		$values = $_POST;
		foreach($values as $k=>$v) {
			if ( preg_match("/\_/",$k) ) {
				list($key,$id) = explode("_",$k);
				$formValues[$id][$key] = $v;
			}
		}
		foreach($formValues as $id=>$value) {
			$query = 0;
			if (isset($value['delete'])) {
				$query = "DELETE FROM ".ARTICLES." WHERE ID = ".$id;
				$query = $this->q($query);
			}
			if (isset($value['hide']) && $value['oldhide'] == 0) {
				$query = "UPDATE ".ARTICLES." SET HIDE = 1 WHERE ID = ".$id;
				$query = $this->q($query);
			} else if (!isset($value['hide']) && $value['oldhide'] == 1) {
				$query = "UPDATE ".ARTICLES." SET HIDE = 0 WHERE ID = ".$id;
				$query = $this->q($query);
			}
		}
		return $this->h->h3($this->tr->w("some values have been modified !"),"class='warning'");
	}
	public function list_articles($pgPos) {
		if ($pgPos) $pgPos = ($pgPos - 1) * ADMINITEMSBYPAGE;
		$siteDat = $this->home_params();
		if (isset($_POST['sort'])) $_SESSION['admin_article_sort'] = $this->sortMethods[$_POST['sort']];
		if (isset($_GET['ownerFilter'])) $_SESSION['admin_articles_filter'] = ARTICLES.".USERID = ".$_GET['ownerFilter'];
        if (isset($_GET['pageFilter'])) $_SESSION['admin_articles_filter'] = ARTICLES.".PAGEID = ".$_GET['pageFilter'];
		if (isset($_POST['search_subject'])) $_SESSION['admin_articles_search_subject'] = " MATCH(".ARTICLES.".SUBJECT) AGAINST('".$this->h->safe($_POST['search_subject'])."') ";
		if (isset($_POST['reset'])) {
			if (isset($_SESSION['admin_articles_filter'])) $_SESSION['admin_articles_filter'] = "";
			if (isset($_SESSION['admin_article_sort'])) $_SESSION['admin_article_sort'] = $this->sortMethods[1];
			if (isset($_SESSION['admin_articles_search_subject'])) $_SESSION['admin_articles_search_subject'] = "";
        }
		$query = $this->qSelect.$this->qFrom;
		$this->qOrderSort = " ORDER BY ".$_SESSION['admin_article_sort']." LIMIT ".$pgPos.",".ADMINITEMSBYPAGE;
		// 1) can create users etc.
		// 2) can create articles, pages and links
		// 3) can create articles everywhere
		// 4) can create articles only in sandbox
		switch ($_SESSION['level']) {
			case 1:
				// user level 1 can't edit others user level 1
				$this->qWhereArray = array();
				if ($_SESSION['userid'] != 1) { // admin edit all
					$this->qWhereArray[] = " (".USERS.".USERLEVEL > ".$_SESSION['level']." OR ".USERS.".ID = ".$_SESSION['userid'].")"; // all level 2, 3 and 4 user's articles, user's articles 
					$this->qWhereArray[] = USERS.".ID != 1"; // but not admin articles
				}
				if (isset($_SESSION['admin_articles_filter']) && $_SESSION['admin_articles_filter'] != "") $this->qWhereArray[] = $_SESSION['admin_articles_filter'];
				if (isset($_SESSION['admin_articles_search_subject']) && $_SESSION['admin_articles_search_subject'] != "") $this->qWhereArray[] = $_SESSION['admin_articles_search_subject'];
				if (count($this->qWhereArray) > 0) $query .= " WHERE ".implode(" AND ",$this->qWhereArray);
				break;
			case 2:
				$this->qWhereArray = array();
				$this->qWhereArray[] = "(".USERS.".ID = ".$_SESSION['userid']." OR ".PAGES.".USERID = ".$_SESSION['userid'].")"; // user's articles and articles in user's pages
				$this->qWhereArray[] = USERS.".ID != 1"; // but not admin articles
				if (isset($_SESSION['admin_articles_filter']) && $_SESSION['admin_articles_filter'] != "") $this->qWhereArray[] = " AND ".$_SESSION['admin_articles_filter'];
				if (isset($_SESSION['admin_articles_search_subject']) && $_SESSION['admin_articles_search_subject'] != "") $this->qWhereArray[] = $_SESSION['admin_articles_search_subject'];
				if (count($this->qWhereArray) > 0) $query .= " WHERE ".implode(" AND ",$this->qWhereArray);
				break;
			case 3:
				$this->qWhereArray = array();
				$this->qWhereArray[] = ARTICLES.".USERID = ".$_SESSION['userid']; // user's articles only
				if (isset($_SESSION['admin_articles_search_subject']) && $_SESSION['admin_articles_search_subject'] != "") $this->qWhereArray[] = $_SESSION['admin_articles_search_subject'];
				if (count($this->qWhereArray) > 0) $query .= " WHERE ".implode(" AND ",$this->qWhereArray);
				break;
			case 4:
				$this->qWhereArray = array();
				$this->qWhereArray[] = ARTICLES.".USERID = ".$_SESSION['userid']; // user's articles only
				if (isset($_SESSION['admin_articles_search_subject']) && $_SESSION['admin_articles_search_subject'] != "") $this->qWhereArray[] = $_SESSION['admin_articles_search_subject'];
				if (count($this->qWhereArray) > 0) $query .= " WHERE ".implode(" AND ",$this->qWhereArray);
				break;
		}
		$query .= $this->qOrderSort;
// print $query.$this->h->br();
// print $this->h->print_rr($_SESSION);
		$query = $this->q($query);
		
		$result = "";
		
		$sort = array($this->tr->w("date")=>1,$this->tr->w("subject")=>2,$this->tr->w("page")=>3,$this->tr->w("user")=>4);
		$type = array_search($_SESSION['admin_article_sort'],$this->sortMethods);
		$sortForm = $this->h->p($this->h->select($sort,"sort",$type)." ".$this->h->input("submit","",$this->tr->w("sort/group by")));
		$result .= $this->h->form($sortForm,"sort","post","admin.php?action=articles");
		
		$searchForm = $this->search_form("search_subject","search subject","articles");
		$goIdForm = $this->go_id("art","modify_article");
		$resetForm = $this->reset_form("articles");
		$result .= $searchForm.$goIdForm.$resetForm;
		
		$artListSubmit = $this->h->p($this->h->input("submit","",$this->tr->w("update all")));
		$artList = $this->h->h3($this->tr->w("articles list"));
		$artList .= $this->h->input("hidden","update",1);
		while ( $line = mysql_fetch_assoc($query) ) {
			$user = isset($line['USERNAME'])?$this->tr->w("by-").$this->h->ahref("admin.php?action=articles&amp;ownerFilter=".$line['IDUSERID'],$this->h->strWidth($line['USERNAME'],16),"class='action' title='".$this->h->uly_htmlentities($line['USERNAME'])."'"):null;
			$page = isset($line['NAME'])?$this->tr->ws("page").$this->h->ahref("admin.php?action=articles&amp;pageFilter=".$line['PAGEID'],$this->h->strWidth($line['NAME'],20),"class='action' title='".$this->h->uly_htmlentities($line['NAME'])."'"):$this->tr->wsp("{page-SandBox}");
			$date = $this->h->input("text","text",$line['DATE'],"size='10' readonly");
			$hideParams = ($line['HIDE'])?" checked=\"checked\"":null;
			$hide = $this->tr->wsp("hide").$this->h->input("checkbox","hide_".$line['ARTID'],"on",$hideParams);
			$hide .= $this->h->input("hidden","oldhide_".$line['ARTID'],$line['HIDE']);
			$modify = $this->h->ahref("admin.php?action=modify_article&amp;art=".$line['ARTID'],$this->tr->w("modify"),"class='action'");
			$subject = " \"".$this->h->strWidth($line['SUBJECT'],32)."\"";
			$view = $this->h->ahref("index.php?k=article&amp;v=".$line['ARTID'],$subject,"class='show' target=_blank title='".$this->h->uly_htmlentities($line['SUBJECT'])."'");
			$delete = $this->tr->w("delete").$this->h->input("checkbox","delete_".$line['ARTID'],"on");
			$artId = "id ".$this->h->fmt($line['ARTID']);
			$content = $artId." ".$date." ".$hide." ".$modify." ".$delete." | ".$page." ".$view." ".$user;
			$artList .= $this->h->p($content);
		}

		$nextPages = $this->h->p($this->next_pages());
		$artList = $artListSubmit.$artList.$nextPages.$artListSubmit;
		$result .= $this->h->form($artList,"articles","post","admin.php?action=articles&amp;pg=".$this->pagePos);
		return $result;
	}
	public function next_pages(){
		$query = $this->qSelectCount.$this->qFrom;
		if (count($this->qWhereArray) > 0) $query .= " WHERE ".implode(" AND ",$this->qWhereArray);
		$query = $this->q($query);
		$line = mysql_fetch_assoc($query);
		$pagesNumbers = new NextPages($line['NUM'],"action=articles");
		$result = $this->h->p($pagesNumbers->numbers());
		$result .= $this->h->p(" (".$this->tr->ws("total articles")." = ".$line['NUM'].")");
		return $result;
	}
}
?>